# trivial< T > Class Template Reference

`#include <_trivial.h>`

List of all members.

## Public Member Functions

| operator reference ()
| operator const_reference () const
reference | get ()
const_reference | get () const
void | construct ()
void | destruct ()
void | destroy ()
template<class U>
reference | operator= (const U &rhs)
template<class U>
reference | operator= (const trivial< U > &rhs)
template<class U>
reference | operator+= (const U &rhs)
template<class U>
reference | operator-= (const U &rhs)
template<class U>
reference | operator*= (const U &rhs)
template<class U>
reference | operator/= (const U &rhs)
template<class U>
reference | operator%= (const U &rhs)
template<class U>
reference | operator^= (const U &rhs)
template<class U>
reference | operator &= (const U &rhs)
template<class U>
reference | operator>>= (const U &rhs)
template<class U>
reference | operator<<= (const U &rhs)
| operator bool () const
bool | operator! () const

## Private Types

typedef T | value_type
typedef T & | reference
typedef const T & | const_reference
typedef T * | pointer
typedef const T * | const_pointer

## Private Attributes

char | data [sizeof(T)]

## Detailed Description

### template<class T>
class trivial< T >

Definition at line 51 of file _trivial.h.

## Member Typedef Documentation

template<class T>

typedef T trivial< T >::value_type `[private]`

Definition at line 53 of file _trivial.h.

template<class T>

typedef T& trivial< T >::reference `[private]`

Definition at line 54 of file _trivial.h.

template<class T>

typedef const T& trivial< T >::const_reference `[private]`

Definition at line 55 of file _trivial.h.

template<class T>

typedef T* trivial< T >::pointer `[private]`

Definition at line 56 of file _trivial.h.

template<class T>

typedef const T* trivial< T >::const_pointer `[private]`

Definition at line 57 of file _trivial.h.

## Member Function Documentation

template<class T>

trivial< T >::operator reference | ( |  | ) | `[inline]`

Definition at line 61 of file _trivial.h.

References trivial< T >::data.

template<class T>

trivial< T >::operator const_reference | ( |  | ) | const`[inline]`

Definition at line 68 of file _trivial.h.

References trivial< T >::data.

template<class T>

reference trivial< T >::get | ( |  | ) | `[inline]`

Definition at line 71 of file _trivial.h.

References trivial< T >::data.

Referenced by trivial< T >::operator=().

template<class T>

const_reference trivial< T >::get | ( |  | ) | const`[inline]`

Definition at line 74 of file _trivial.h.

References trivial< T >::data.

template<class T>

void trivial< T >::construct | ( |  | ) | `[inline]`

Definition at line 77 of file _trivial.h.

template<class T>

void trivial< T >::destruct | ( |  | ) | `[inline]`

Definition at line 80 of file _trivial.h.

Referenced by trivial< T >::destroy().

template<class T>

void trivial< T >::destroy | ( |  | ) | `[inline]`

Definition at line 83 of file _trivial.h.

References trivial< T >::destruct().

template<class T>
template<class U>

reference trivial< T >::operator= | ( | const U & | rhs | ) | `[inline]`

Definition at line 86 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator= | ( | const trivial< U > & | rhs | ) | `[inline]`

Definition at line 90 of file _trivial.h.

References trivial< T >::get().

template<class T>
template<class U>

reference trivial< T >::operator+= | ( | const U & | rhs | ) | `[inline]`

Definition at line 94 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator-= | ( | const U & | rhs | ) | `[inline]`

Definition at line 98 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator*= | ( | const U & | rhs | ) | `[inline]`

Definition at line 102 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator/= | ( | const U & | rhs | ) | `[inline]`

Definition at line 106 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator%= | ( | const U & | rhs | ) | `[inline]`

Definition at line 110 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator^= | ( | const U & | rhs | ) | `[inline]`

Definition at line 114 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator &= | ( | const U & | rhs | ) | `[inline]`

Definition at line 118 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator>>= | ( | const U & | rhs | ) | `[inline]`

Definition at line 122 of file _trivial.h.

template<class T>
template<class U>

reference trivial< T >::operator<<= | ( | const U & | rhs | ) | `[inline]`

Definition at line 126 of file _trivial.h.

template<class T>

trivial< T >::operator bool | ( |  | ) | const`[inline]`

Definition at line 129 of file _trivial.h.

template<class T>

bool trivial< T >::operator! | ( |  | ) | const`[inline]`

Definition at line 132 of file _trivial.h.

## Member Data Documentation

template<class T>

char trivial< T >::data[sizeof(T)]`[private]`

Definition at line 59 of file _trivial.h.

Referenced by trivial< T >::get(), trivial< T >::operator const_reference(), and trivial< T >::operator reference().

The documentation for this class was generated from the following file:

- _trivial.h